using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Configuration;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;

namespace FlickrExplorer
{
	/// <summary>
	/// Description rsume de Preferences.
	/// </summary>
	public class Preferences : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TextBox ProxyUser;
		private System.Windows.Forms.TextBox ProxyPassword;
		private System.Windows.Forms.TextBox ProxyAddress;
		private System.Windows.Forms.CheckBox ProxyAuthenticationRequired;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox ProxyPort;

		private configuration cfg;

		public Preferences()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			try
			{
				cfg = ConfigurationManager.GetConfiguration(configuration.FlickrExplorerSettings) as configuration;
				
				ProxyAddress.Text = cfg.ProxyAddress;
				ProxyAuthenticationRequired.Checked = cfg.ProxyAuthenticationRequired;
				ProxyPassword.Text = cfg.ProxyPassword;
				ProxyUser.Text = cfg.ProxyUser;
				ProxyPort.Text = cfg.ProxyPort;
			}
			catch (Exception ex)
			{
				cfg = new configuration();
				System.Windows.Forms.MessageBox.Show(ex.ToString());
			}
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.ProxyUser = new System.Windows.Forms.TextBox();
			this.ProxyPassword = new System.Windows.Forms.TextBox();
			this.ProxyAddress = new System.Windows.Forms.TextBox();
			this.ProxyAuthenticationRequired = new System.Windows.Forms.CheckBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.ProxyPort = new System.Windows.Forms.TextBox();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(234, 279);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.label4);
			this.tabPage1.Controls.Add(this.ProxyPort);
			this.tabPage1.Controls.Add(this.label3);
			this.tabPage1.Controls.Add(this.label2);
			this.tabPage1.Controls.Add(this.label1);
			this.tabPage1.Controls.Add(this.ProxyAuthenticationRequired);
			this.tabPage1.Controls.Add(this.ProxyAddress);
			this.tabPage1.Controls.Add(this.ProxyPassword);
			this.tabPage1.Controls.Add(this.ProxyUser);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(226, 253);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Connection";
			// 
			// ProxyUser
			// 
			this.ProxyUser.Enabled = false;
			this.ProxyUser.Location = new System.Drawing.Point(8, 144);
			this.ProxyUser.Name = "ProxyUser";
			this.ProxyUser.Size = new System.Drawing.Size(208, 20);
			this.ProxyUser.TabIndex = 0;
			this.ProxyUser.Text = "";
			// 
			// ProxyPassword
			// 
			this.ProxyPassword.Enabled = false;
			this.ProxyPassword.Location = new System.Drawing.Point(8, 184);
			this.ProxyPassword.Name = "ProxyPassword";
			this.ProxyPassword.PasswordChar = '*';
			this.ProxyPassword.Size = new System.Drawing.Size(208, 20);
			this.ProxyPassword.TabIndex = 1;
			this.ProxyPassword.Text = "";
			// 
			// ProxyAddress
			// 
			this.ProxyAddress.Location = new System.Drawing.Point(8, 24);
			this.ProxyAddress.Name = "ProxyAddress";
			this.ProxyAddress.Size = new System.Drawing.Size(208, 20);
			this.ProxyAddress.TabIndex = 2;
			this.ProxyAddress.Text = "";
			// 
			// ProxyAuthenticationRequired
			// 
			this.ProxyAuthenticationRequired.Location = new System.Drawing.Point(8, 88);
			this.ProxyAuthenticationRequired.Name = "ProxyAuthenticationRequired";
			this.ProxyAuthenticationRequired.Size = new System.Drawing.Size(144, 24);
			this.ProxyAuthenticationRequired.TabIndex = 3;
			this.ProxyAuthenticationRequired.Text = "Authentication required";
			this.ProxyAuthenticationRequired.CheckedChanged += new System.EventHandler(this.ProxyAuthenticationRequired_CheckedChanged);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.button2);
			this.panel1.Controls.Add(this.button1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 239);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(234, 40);
			this.panel1.TabIndex = 1;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "&Save";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(88, 8);
			this.button2.Name = "button2";
			this.button2.TabIndex = 1;
			this.button2.Text = "&Cancel";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Proxy Address :";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 168);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Proxy password :";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 128);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "Proxy user :";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(9, 48);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(100, 16);
			this.label4.TabIndex = 8;
			this.label4.Text = "Port :";
			// 
			// ProxyPort
			// 
			this.ProxyPort.Location = new System.Drawing.Point(9, 64);
			this.ProxyPort.Name = "ProxyPort";
			this.ProxyPort.Size = new System.Drawing.Size(87, 20);
			this.ProxyPort.TabIndex = 7;
			this.ProxyPort.Text = "";
			// 
			// Preferences
			// 
            this.AutoScaleDimensions = new SizeF(5, 13);
			this.ClientSize = new System.Drawing.Size(234, 279);
			this.ControlBox = false;
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.tabControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "Preferences";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Preferences";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void ProxyAuthenticationRequired_CheckedChanged(object sender, System.EventArgs e)
		{
			if (ProxyAuthenticationRequired.Checked)
			{
				ProxyUser.Enabled = true;
				ProxyPassword.Enabled = true;
			}
			else
			{
				ProxyUser.Enabled = false;
				ProxyPassword.Enabled = false;
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			cfg.ProxyPort = ProxyPort.Text;
			cfg.ProxyAddress = ProxyAddress.Text;
			cfg.ProxyAuthenticationRequired = ProxyAuthenticationRequired.Checked;
			cfg.ProxyPassword = ProxyPassword.Text;
			cfg.ProxyUser = ProxyUser.Text;
			ConfigurationManager.WriteConfiguration(configuration.FlickrExplorerSettings,cfg);
			DialogResult = DialogResult.OK;
			Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();
		}
	}
}
